Lattice Grid Buy a licence

demo D178

Charts with no grid on screen

The data engine driving charts on its own

createHeadlessGrid

Building…
Loading a live grid…

The configuration

<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/lattice-grid.min.css">

<div id="app"></div>

<script type="module">
  import React from 'https://esm.sh/react@18';
  import { createRoot } from 'https://esm.sh/react-dom@18/client';
  import { createHeadlessGrid } from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/lattice-grid.esm.min.js';
  import { createChart } from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/modules/charts.esm.min.js';

  const columns = [
    { field: 'circuit', title: 'Circuit', layout: { width: 180 } },
    { field: 'region', title: 'Region', filter: { type: 'set' } },
    { field: 'status', title: 'Status', filter: { type: 'set' } },
    { field: 'bandwidth', title: 'Bandwidth', type: 'number' },
    { field: 'charge', title: 'Monthly charge', type: 'number',
      format: { style: 'currency', currency: 'GBP' }, total: 'sum' },
  ];

  const rows = [/* circuit records */];

  function App() {
    React.useEffect(() => {
      // createHeadlessGrid holds and shapes the data with no table drawn at all.
      // The charts read it exactly as they read a visible grid, with the same
      // follow behaviour: filter the headless grid and every chart redraws.
      const grid = createHeadlessGrid({ rowKey: 'id', columns, rows });
      createChart({ grid, container: '#by-region', type: 'bar',       x: 'region', y: 'charge', title: 'by region' });
      createChart({ grid, container: '#by-status', type: 'donut',     x: 'status', y: 'charge', title: 'by status' });
      createChart({ grid, container: '#distribution', type: 'histogram', y: 'charge',            title: 'distribution' });
    }, []);

    return (
      <div style={{ display: 'grid', gridTemplateColumns: 'repeat(3, 1fr)', gap: '14px', height: '260px' }}>
        <div id="by-region" />
        <div id="by-status" />
        <div id="distribution" />
      </div>
    );
  }

  createRoot(document.getElementById('app')).render(<App />);
</script>

Lattice Grid Buy a licence

demo D178

Charts with no grid on screen

The data engine driving charts on its own

createHeadlessGrid

Building…
Loading a live grid…

The configuration

import * as ng from '@angular/core';
import { Component, AfterViewInit } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { createHeadlessGrid } from '@toclocoinc/lattice-grid';
import '@toclocoinc/lattice-grid/css';
import { createChart } from '@toclocoinc/lattice-grid/modules/charts';

const columns = [
  { field: 'circuit', title: 'Circuit', layout: { width: 180 } },
  { field: 'region', title: 'Region', filter: { type: 'set' } },
  { field: 'status', title: 'Status', filter: { type: 'set' } },
  { field: 'bandwidth', title: 'Bandwidth', type: 'number' },
  { field: 'charge', title: 'Monthly charge', type: 'number',
    format: { style: 'currency', currency: 'GBP' }, total: 'sum' },
];

@Component({
  selector: 'app-root',
  standalone: true,
  template:
    '<div style="display:grid;grid-template-columns:repeat(3, 1fr);gap:14px;height:260px">' +
    '  <div id="by-region"></div>' +
    '  <div id="by-status"></div>' +
    '  <div id="distribution"></div>' +
    '</div>',
})
export class AppComponent implements AfterViewInit {
  // createHeadlessGrid holds and shapes the data with no table drawn at all. The
  // charts read it exactly as they read a visible grid, with the same follow
  // behaviour: filter the headless grid and every chart redraws.
  ngAfterViewInit() {
    const grid = createHeadlessGrid({ rowKey: 'id', columns, rows: [/* circuit records */] });
    createChart({ grid, container: '#by-region', type: 'bar',       x: 'region', y: 'charge', title: 'by region' });
    createChart({ grid, container: '#by-status', type: 'donut',     x: 'status', y: 'charge', title: 'by status' });
    createChart({ grid, container: '#distribution', type: 'histogram', y: 'charge',            title: 'distribution' });
  }
}

bootstrapApplication(AppComponent);

Lattice Grid Buy a licence

demo D178

Charts with no grid on screen

The data engine driving charts on its own

createHeadlessGrid

Building…
Loading a live grid…

The configuration

<script>
  import { createHeadlessGrid } from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/lattice-grid.esm.min.js';
  import { createChart } from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/modules/charts.esm.min.js';
  import { onMount } from 'svelte';

  let byRegionEl;
  let byStatusEl;
  let distributionEl;

  const config = {
    rowKey: 'id',
    columns: [
      { field: 'circuit', title: 'Circuit', layout: { width: 180 } },
      { field: 'region', title: 'Region', filter: { type: 'set' } },
      { field: 'status', title: 'Status', filter: { type: 'set' } },
      { field: 'bandwidth', title: 'Bandwidth', type: 'number' },
      { field: 'charge', title: 'Monthly charge', type: 'number',
        format: { style: 'currency', currency: 'GBP' }, total: 'sum' },
    ],
    rows,  // an array of circuit records
  };

  // No visible table: createHeadlessGrid is the data engine on its own, and
  // every chart draws from it, with the same follow behaviour.
  onMount(() => {
    const grid = createHeadlessGrid(config);
    createChart({ grid, container: byRegionEl,     type: 'bar',       x: 'region', y: 'charge' });
    createChart({ grid, container: byStatusEl,     type: 'donut',     x: 'status', y: 'charge' });
    createChart({ grid, container: distributionEl, type: 'histogram', y: 'charge' });
    return () => grid.destroy();
  });
</script>

<svelte:head>
  <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/lattice-grid.min.css">
</svelte:head>

<div style="display: grid; grid-template-columns: repeat(3, 1fr); gap: 14px; height: 260px">
  <div bind:this={byRegionEl}></div>
  <div bind:this={byStatusEl}></div>
  <div bind:this={distributionEl}></div>
</div>